//----------------------------------------------------------------------------
#ifndef MAIN_H_
#define MAIN_H_
//----------------------------------------------------------------------------
// pin definitions
#define DATABUS_L_DIR                 DDRC
#define DATABUS_L_DATA                PORTC
#define DATABUS_L_MASK                0x0F
#define DATABUS_H_DIR                 DDRD
#define DATABUS_H_DATA                PORTD
#define DATABUS_H_MASK                0xF0

#define MEM_A14_DIR                   DDRC
#define MEM_A14_PORT                  PORTC
#define MEM_A14_BIT                   _BV(4)
#define MEM_ALE_DIR                   DDRC
#define MEM_ALE_PORT                  PORTC
#define MEM_ALE_BIT                   _BV(5)
#define MEM_CSW_DIR                   DDRD
#define MEM_CSW_PORT                  PORTD
#define MEM_CSW_BIT                   _BV(2)
#define MEM_WEM_DIR                   DDRD
#define MEM_WEM_PORT                  PORTD
#define MEM_WEM_BIT                   _BV(3)

// macros
#define switch_memory_bank_0()        MEM_A14_PORT &= ~MEM_A14_BIT
#define switch_memory_bank_1()        MEM_A14_PORT |= MEM_A14_BIT

#define select_card()                 PORTB &= ~(1 << PINB2)
#define unselect_card()               PORTB |= (1 << PINB2)

//----------------------------------------------------------------------------
typedef void (*jump_t)(void);

#define CMD_OK()    uart_send_byte('Y')
#define CMD_FAIL()  uart_send_byte('N')

//----------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------
