//----------------------------------------------------------------------------
#include <stdint.h>
#include <avr/io.h>

#include "uart.h"

//-----------------------------------------------------------------------------
void uart_init(void)
{
  /* set baud rate */
  UBRR0H = UBRRVAL >> 8;
  UBRR0L = UBRRVAL & 0xFF;

  UCSR0A = _BV(TXC0);
  /* set frame format: 8 bit, no parity, 1 stop bit */
  UCSR0C = _BV(UCSZ01) | _BV(UCSZ00);
  /* enable serial receiver and transmitter */
  UCSR0B = _BV(RXEN0) | _BV(TXEN0);
}
//----------------------------------------------------------------------------
void uart_send_byte(uint8_t bt)
{
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = bt;
}
//----------------------------------------------------------------------------
uint8_t uart_read_byte(void)
{
  uint8_t bt;

  loop_until_bit_is_set(UCSR0A, RXC0);
  bt = UDR0;

  return bt;
}
//-----------------------------------------------------------------------------
